public class Sedile
{
	/**
	* Contatore delle istanze di Sedile.
	*/
	static int contatore = 0;

	boolean occupato;
	boolean mobile;

	public Sedile(boolean occ, boolean mob)
	{
		contatore++;
		//contatore = contatore + 1;
		occupato = occ;
		mobile = mob;
	}

	public static int quanti()
	{
		return contatore;
	}

	/**
	* Tenta di occupare il sedile. Se il sedile e' gia' occupato fallisce e ritorna false. Se il sedile e' libero lo occupa e ritorna true.
	*/
	public boolean occupa()
	{
		if(occupato)
		{
			return false;
		}
		occupato = true;
		return true;
	}

	/**
	* Libera il sedile. Se il sedile era gia' libero ritorna false. Se ha liberato effettivamente il sedile ritorna true.
	*/
	public boolean libera()
	{
		boolean retval = occupato;
		occupato = false;
		return retval;
	}

	/**
	* Ritorna lo stato mobile o no del sedile.
	*/
	public boolean isMobile()
	{
		return mobile;
	}

	/**
	* Ritorna lo stato occupato o no del sedile.
	*/
	public boolean isOccupato()
	{
		return occupato;
	}

	public static void main(String[] argv)
	{
		int i = 0;
		Sedile[] sedili = null;
		/*
		sedili = new Sedile[argv.length];
		for(i=0;i<argv.length;i++)
		{
			sedili[i] = new Sedile(false, false);
		}
		*/

		int cont = Integer.parseInt(argv[0]);
		sedili = new Sedile[cont];
		for(i=0;i<cont;i++)
		{
			sedili[i] = new Sedile(false, true);
		}

		for(i=0;i<sedili.length;i++)
		{
			System.out.println(sedili[i]);
		}

		System.out.println("Ho istanziato " + Sedile.quanti() + " sedili");
		Sedile sedile = new Sedile(false, true);
		System.out.println("Ho istanziato " + Sedile.quanti() + " sedili");
		Sedile sedile1 = new Sedile(false, false);
		System.out.println("Ho istanziato " + Sedile.quanti() + " sedili");
		Sedile sedile2 = new Sedile(true, false);
		System.out.println("Ho istanziato " + Sedile.quanti() + " sedili");
		System.out.println(sedile2);
		if(argv.length > 0)
		{
			if(sedile.occupa())
			{
				System.out.println("Ho occupato il sedile " + sedile);
			}
			else
			{
				System.out.println("Non ho potuto occupare il sedile " + sedile);
			}
		}
		else
		{
			if(sedile.libera())
			{
				System.out.println("Ho liberato il sedile " + sedile);
			}
			else
			{
				System.out.println("Il sedile " + sedile + " era gia libero");
			}
		}
	}
}
